Subject: Re: Optics (SFP) monitoring on ixgbe and igbe

From: Jeff Kirsher <[email-masked]>
Date: Thu, 15 Nov 2012 14:46:47 -0800

On 11/15/2012 01:36 PM, Aurélien wrote:
>> On Fri, Nov 9, 2012 at 4:08 PM, Ben Hutchings <[email-masked]> wrote:
>>> No, the driver also needs to implement ethtool_ops::get_module_info and
>>> ethtool_ops::get_module_eeprom.  But those should be quite easy to do.
>>>
> Hi !
>
> I started to implement these operations in ixgbe.
>
> So far, the result is the attached patch, which applies on dave-m's
> net-next @ 1ff05fb7114a6b4118e0f7d89fed2659f7131b0a. It's not yet
> finished, and since it is my first peek at network drivers I need some
> advice on:
>
> - whether the implementation seems correct for ixgbe and all its
> supported MAC/PHY combinations ?
> - what would be the best way to manage SFF-8472 A0/A2 bank swapping
> mechanism for reading A2h ? (it seems I need to lock the whole -
> adress change sequence - read A2h - address change again - operation)
> in case it's needed. I may not be able to test that, so I may add an
> unsupported return code for now.
> - Is the supported PHY selection correct, or should other PHYs be
> supported ? What should be the rule ?
>
> I have been able to get correct temperature readings with a patched-up
> ethtool, so it seems to work correctly on at least my card (Ethernet
> controller [0200]: Intel Corporation 82599EB 10-Gigabit Network
> Connection [8086:10fb] (rev 01)).
>
> About ethtool, I was thinking about making a -O option for optical
> diagnostics, which would have a readable output. I will make a
> function to parse the A2 register contents, so it can be reused in
> other daemons/libs (SNMP, etc).
>
> Thanks,
> Best regards,
Can you please add me <[email-masked]> to the CC on future
patches for ixgbe or ixgb, as I will be the one applying the patch to my
queue?

Thanks
Jeff